diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index 842be68..5d48c8f 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -16747,7 +16747,7 @@ ix86_expand_move (enum machine_mode mode, rtx operands[])
 	}
     }
 
-  if ((flag_pic || MACHOPIC_INDIRECT)
+  if ((GCC_OPTION (flag_pic) || MACHOPIC_INDIRECT)
       && symbolic_operand (op1, mode))
     {
       if (TARGET_MACHO && !TARGET_64BIT)
@@ -16819,7 +16819,7 @@ ix86_expand_move (enum machine_mode mode, rtx operands[])
 	  && immediate_operand (op1, mode)
 	  && !x86_64_zext_immediate_operand (op1, VOIDmode)
 	  && !register_operand (op0, mode)
-	  && optimize)
+	  && GCC_OPTION (optimize))
 	op1 = copy_to_mode_reg (mode, op1);
 
       if (can_create_pseudo_p ()
@@ -18217,7 +18217,7 @@ ix86_avoid_lea_for_addr (rtx insn, rtx operands[])
 
   /* We should not split into add if non legitimate pic
      operand is used as displacement. */
-  if (parts.disp && flag_pic && !LEGITIMATE_PIC_OPERAND_P (parts.disp))
+  if (parts.disp && GCC_OPTION (flag_pic) && !LEGITIMATE_PIC_OPERAND_P (parts.disp))
     return false;
 
   regno0 = true_regnum (operands[0]) ;
@@ -20769,7 +20769,7 @@ ix86_expand_sse_fp_minmax (rtx dest, enum rtx_code code, rtx cmp_op0,
 
   /* We want to check HONOR_NANS and HONOR_SIGNED_ZEROS here,
      but MODE may be a vector mode and thus not appropriate.  */
-  if (!flag_finite_math_only || !flag_unsafe_math_optimizations)
+  if (!GCC_OPTION (flag_finite_math_only) || !GCC_OPTION (flag_unsafe_math_optimizations))
     {
       int u = is_min ? UNSPEC_IEEE_MIN : UNSPEC_IEEE_MAX;
       rtvec v;
@@ -20819,7 +20819,7 @@ ix86_expand_sse_cmp (rtx dest, enum rtx_code code, rtx cmp_op0, rtx cmp_op1,
   if (!nonimmediate_operand (cmp_op1, cmp_ops_mode))
     cmp_op1 = force_reg (cmp_ops_mode, cmp_op1);
 
-  if (optimize
+  if (GCC_OPTION (optimize)
       || reg_overlap_mentioned_p (dest, op_true)
       || reg_overlap_mentioned_p (dest, op_false))
     dest = gen_reg_rtx (maskcmp ? cmp_mode : mode);
@@ -21000,7 +21000,7 @@ ix86_expand_sse_movcc (rtx dest, rtx cmp, rtx op_true, rtx op_false)
 	  op_true = force_reg (mode, op_true);
 
 	  t2 = gen_reg_rtx (mode);
-	  if (optimize)
+	  if (GCC_OPTION (optimize))
 	    t3 = gen_reg_rtx (mode);
 	  else
 	    t3 = dest;
@@ -23837,9 +23837,9 @@ decide_alg (HOST_WIDE_INT count, HOST_WIDE_INT expected_size,
     expected_size = min_size / 2 + max_size / 2;
 
   /* If user specified the algorithm, honnor it if possible.  */
-  if (ix86_stringop_alg != no_stringop
-      && alg_usable_p (ix86_stringop_alg, memset))
-    return ix86_stringop_alg;
+  if (GCC_OPTION (ix86_stringop_alg) != no_stringop
+      && alg_usable_p (GCC_OPTION (ix86_stringop_alg), memset))
+    return GCC_OPTION (ix86_stringop_alg);
   /* rep; movq or rep; movl is the smallest variant.  */
   else if (!optimize_for_speed)
     {
@@ -23959,7 +23959,7 @@ decide_alignment (int align,
       && (alg == rep_prefix_4_byte || alg == rep_prefix_1_byte))
     desired_align = 8;
 
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     desired_align = 1;
   if (desired_align < align)
     desired_align = align;
@@ -24750,7 +24750,7 @@ ix86_expand_strlen (rtx out, rtx src, rtx eoschar, rtx align)
   /* The generic case of strlen expander is long.  Avoid it's
      expanding unless TARGET_INLINE_ALL_STRINGOPS.  */
 
-  if (TARGET_UNROLL_STRLEN && eoschar == const0_rtx && optimize > 1
+  if (TARGET_UNROLL_STRLEN && eoschar == const0_rtx && GCC_OPTION (optimize) > 1
       && !TARGET_INLINE_ALL_STRINGOPS
       && !optimize_insn_for_size_p ()
       && (!CONST_INT_P (align) || INTVAL (align) < 4))
@@ -24759,7 +24759,7 @@ ix86_expand_strlen (rtx out, rtx src, rtx eoschar, rtx align)
   addr = force_reg (Pmode, XEXP (src, 0));
   scratch1 = gen_reg_rtx (Pmode);
 
-  if (TARGET_UNROLL_STRLEN && eoschar == const0_rtx && optimize > 1
+  if (TARGET_UNROLL_STRLEN && eoschar == const0_rtx && GCC_OPTION (optimize) > 1
       && !optimize_insn_for_size_p ())
     {
       /* Well it seems that some optimizer does not combine a call like
@@ -24814,7 +24814,7 @@ construct_plt_address (rtx symbol)
   rtx tmp, unspec;
 
   gcc_assert (GET_CODE (symbol) == SYMBOL_REF);
-  gcc_assert (ix86_cmodel == CM_LARGE_PIC && !TARGET_PECOFF);
+  gcc_assert (GCC_OPTION (ix86_cmodel) == CM_LARGE_PIC && !TARGET_PECOFF);
   gcc_assert (Pmode == DImode);
 
   tmp = gen_reg_rtx (Pmode);
@@ -24843,16 +24843,16 @@ ix86_expand_call (rtx retval, rtx fnaddr, rtx callarg1,
   if (TARGET_MACHO && !TARGET_64BIT)
     {
 #if TARGET_MACHO
-      if (flag_pic && GET_CODE (XEXP (fnaddr, 0)) == SYMBOL_REF)
+      if (GCC_OPTION (flag_pic) && GET_CODE (XEXP (fnaddr, 0)) == SYMBOL_REF)
 	fnaddr = machopic_indirect_call_target (fnaddr);
 #endif
     }
   else
     {
       /* Static functions and indirect calls don't need the pic register.  */
-      if (flag_pic
+      if (GCC_OPTION (flag_pic)
 	  && (!TARGET_64BIT
-	      || (ix86_cmodel == CM_LARGE_PIC
+	      || (GCC_OPTION (ix86_cmodel) == CM_LARGE_PIC
 		  && DEFAULT_ABI != MS_ABI))
 	  && GET_CODE (XEXP (fnaddr, 0)) == SYMBOL_REF
 	  && ! SYMBOL_REF_LOCAL_P (XEXP (fnaddr, 0)))
@@ -24866,7 +24866,7 @@ ix86_expand_call (rtx retval, rtx fnaddr, rtx callarg1,
       use_reg (&use, al);
     }
 
-  if (ix86_cmodel == CM_LARGE_PIC
+  if (GCC_OPTION (ix86_cmodel) == CM_LARGE_PIC
       && !TARGET_PECOFF
       && MEM_P (fnaddr)
       && GET_CODE (XEXP (fnaddr, 0)) == SYMBOL_REF
@@ -24959,7 +24959,7 @@ ix86_output_call_insn (rtx insn, rtx call_op)
 	     being adjacent to the standard epilogue sequence.  If non-
 	     call-exceptions, we'll have done this during epilogue emission. */
 	  if (NOTE_P (i) && NOTE_KIND (i) == NOTE_INSN_EPILOGUE_BEG
-	      && !flag_non_call_exceptions
+	      && !GCC_OPTION (flag_non_call_exceptions)
 	      && !can_throw_internal (insn))
 	    {
 	      seh_nop_p = true;
@@ -24997,7 +24997,7 @@ ix86_init_machine_status (void)
 
   f = ggc_alloc_cleared_machine_function ();
   f->use_fast_prologue_epilogue_nregs = -1;
-  f->call_abi = ix86_abi;
+  f->call_abi = GCC_OPTION (ix86_abi);
 
   return f;
 }
@@ -26547,7 +26547,7 @@ ix86_constant_alignment (tree exp, int align)
       else if (ALIGN_MODE_128 (TYPE_MODE (TREE_TYPE (exp))) && align < 128)
 	return 128;
     }
-  else if (!optimize_size && TREE_CODE (exp) == STRING_CST
+  else if (!GCC_OPTION (optimize_size) && TREE_CODE (exp) == STRING_CST
 	   && TREE_STRING_LENGTH (exp) >= 31 && align < BITS_PER_WORD)
     return BITS_PER_WORD;
 
@@ -26569,7 +26569,7 @@ ix86_data_alignment (tree type, int align, bool opt)
      used to assume.  */
 
   int max_align_compat
-    = optimize_size ? BITS_PER_WORD : MIN (256, MAX_OFILE_ALIGNMENT);
+    = GCC_OPTION (optimize_size) ? BITS_PER_WORD : MIN (256, MAX_OFILE_ALIGNMENT);
 
   /* A data structure, equal or greater than the size of a cache line
      (64 bytes in the Pentium 4 and other recent Intel processors, including
@@ -28784,7 +28784,7 @@ def_builtin (HOST_WIDE_INT mask, const char *name,
 
       mask &= ~OPTION_MASK_ISA_64BIT;
       if (mask == 0
-	  || (mask & ix86_isa_flags) != 0
+	  || (mask & GCC_OPTION (ix86_isa_flags)) != 0
 	  || (lang_hooks.builtin_function
 	      == lang_hooks.builtin_function_ext_scope))
 
@@ -30642,7 +30642,7 @@ ix86_init_tm_builtins (void)
   tree attrs_load, attrs_type_load, attrs_store, attrs_type_store;
   tree attrs_log, attrs_type_log;
 
-  if (!flag_tm)
+  if (!GCC_OPTION (flag_tm))
     return;
 
   /* If there are no builtins defined, we must be compiling in a
@@ -30667,7 +30667,7 @@ ix86_init_tm_builtins (void)
        i < ARRAY_SIZE (bdesc_tm);
        i++, d++)
     {
-      if ((d->mask & ix86_isa_flags) != 0
+      if ((d->mask & GCC_OPTION (ix86_isa_flags)) != 0
 	  || (lang_hooks.builtin_function
 	      == lang_hooks.builtin_function_ext_scope))
 	{
@@ -32730,7 +32730,7 @@ ix86_expand_binop_builtin (enum insn_code icode, tree exp, rtx target)
   if (VECTOR_MODE_P (mode1))
     op1 = safe_vector_operand (op1, mode1);
 
-  if (optimize || !target
+  if (GCC_OPTION (optimize) || !target
       || GET_MODE (target) != tmode
       || !insn_data[icode].operand[0].predicate (target, tmode))
     target = gen_reg_rtx (tmode);
@@ -32860,7 +32860,7 @@ ix86_expand_multi_arg_builtin (enum insn_code icode, tree exp, rtx target,
       gcc_unreachable ();
     }
 
-  if (optimize || !target
+  if (GCC_OPTION (optimize) || !target
       || GET_MODE (target) != tmode
       || !insn_data[icode].operand[0].predicate (target, tmode))
     target = gen_reg_rtx (tmode);
@@ -32939,7 +32939,7 @@ ix86_expand_multi_arg_builtin (enum insn_code icode, tree exp, rtx target,
 
 	  gcc_assert (GET_MODE (op) == mode || GET_MODE (op) == VOIDmode);
 
-	  if (optimize
+	  if (GCC_OPTION (optimize)
 	      || !insn_data[icode].operand[i+adjust+1].predicate (op, mode)
 	      || num_memory > 1)
 	    op = force_reg (mode, op);
@@ -33003,7 +33003,7 @@ ix86_expand_unop_vec_merge_builtin (enum insn_code icode, tree exp,
   enum machine_mode tmode = insn_data[icode].operand[0].mode;
   enum machine_mode mode0 = insn_data[icode].operand[1].mode;
 
-  if (optimize || !target
+  if (GCC_OPTION (optimize) || !target
       || GET_MODE (target) != tmode
       || !insn_data[icode].operand[0].predicate (target, tmode))
     target = gen_reg_rtx (tmode);
@@ -33011,7 +33011,7 @@ ix86_expand_unop_vec_merge_builtin (enum insn_code icode, tree exp,
   if (VECTOR_MODE_P (mode0))
     op0 = safe_vector_operand (op0, mode0);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_data[icode].operand[1].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
 
@@ -33058,15 +33058,15 @@ ix86_expand_sse_compare (const struct builtin_description *d,
       op0 = tmp;
     }
 
-  if (optimize || !target
+  if (GCC_OPTION (optimize) || !target
       || GET_MODE (target) != tmode
       || !insn_data[d->icode].operand[0].predicate (target, tmode))
     target = gen_reg_rtx (tmode);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_data[d->icode].operand[1].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
-  if ((optimize && !register_operand (op1, mode1))
+  if ((GCC_OPTION (optimize) && !register_operand (op1, mode1))
       || !insn_data[d->icode].operand[2].predicate (op1, mode1))
     op1 = copy_to_mode_reg (mode1, op1);
 
@@ -33111,10 +33111,10 @@ ix86_expand_sse_comi (const struct builtin_description *d, tree exp,
   emit_move_insn (target, const0_rtx);
   target = gen_rtx_SUBREG (QImode, target, 0);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_data[d->icode].operand[0].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
-  if ((optimize && !register_operand (op1, mode1))
+  if ((GCC_OPTION (optimize) && !register_operand (op1, mode1))
       || !insn_data[d->icode].operand[1].predicate (op1, mode1))
     op1 = copy_to_mode_reg (mode1, op1);
 
@@ -33143,7 +33143,7 @@ ix86_expand_sse_round (const struct builtin_description *d, tree exp,
   enum machine_mode tmode = insn_data[d->icode].operand[0].mode;
   enum machine_mode mode0 = insn_data[d->icode].operand[1].mode;
 
-  if (optimize || target == 0
+  if (GCC_OPTION (optimize) || target == 0
       || GET_MODE (target) != tmode
       || !insn_data[d->icode].operand[0].predicate (target, tmode))
     target = gen_reg_rtx (tmode);
@@ -33151,7 +33151,7 @@ ix86_expand_sse_round (const struct builtin_description *d, tree exp,
   if (VECTOR_MODE_P (mode0))
     op0 = safe_vector_operand (op0, mode0);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_data[d->icode].operand[0].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
 
@@ -33178,7 +33178,7 @@ ix86_expand_sse_round_vec_pack_sfix (const struct builtin_description *d,
   enum machine_mode mode0 = insn_data[d->icode].operand[1].mode;
   enum machine_mode mode1 = insn_data[d->icode].operand[2].mode;
 
-  if (optimize || target == 0
+  if (GCC_OPTION (optimize) || target == 0
       || GET_MODE (target) != tmode
       || !insn_data[d->icode].operand[0].predicate (target, tmode))
     target = gen_reg_rtx (tmode);
@@ -33186,10 +33186,10 @@ ix86_expand_sse_round_vec_pack_sfix (const struct builtin_description *d,
   op0 = safe_vector_operand (op0, mode0);
   op1 = safe_vector_operand (op1, mode1);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_data[d->icode].operand[0].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
-  if ((optimize && !register_operand (op1, mode1))
+  if ((GCC_OPTION (optimize) && !register_operand (op1, mode1))
       || !insn_data[d->icode].operand[1].predicate (op1, mode1))
     op1 = copy_to_mode_reg (mode1, op1);
 
@@ -33226,10 +33226,10 @@ ix86_expand_sse_ptest (const struct builtin_description *d, tree exp,
   emit_move_insn (target, const0_rtx);
   target = gen_rtx_SUBREG (QImode, target, 0);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_data[d->icode].operand[0].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
-  if ((optimize && !register_operand (op1, mode1))
+  if ((GCC_OPTION (optimize) && !register_operand (op1, mode1))
       || !insn_data[d->icode].operand[1].predicate (op1, mode1))
     op1 = copy_to_mode_reg (mode1, op1);
 
@@ -33283,7 +33283,7 @@ ix86_expand_sse_pcmpestr (const struct builtin_description *d,
     op0 = copy_to_mode_reg (modev2, op0);
   if (!insn_data[d->icode].operand[3].predicate (op1, modei3))
     op1 = copy_to_mode_reg (modei3, op1);
-  if ((optimize && !register_operand (op2, modev4))
+  if ((GCC_OPTION (optimize) && !register_operand (op2, modev4))
       || !insn_data[d->icode].operand[4].predicate (op2, modev4))
     op2 = copy_to_mode_reg (modev4, op2);
   if (!insn_data[d->icode].operand[5].predicate (op3, modei5))
@@ -33297,7 +33297,7 @@ ix86_expand_sse_pcmpestr (const struct builtin_description *d,
 
   if (d->code == IX86_BUILTIN_PCMPESTRI128)
     {
-      if (optimize || !target
+      if (GCC_OPTION (optimize) || !target
 	  || GET_MODE (target) != tmode0
 	  || !insn_data[d->icode].operand[0].predicate (target, tmode0))
 	target = gen_reg_rtx (tmode0);
@@ -33308,7 +33308,7 @@ ix86_expand_sse_pcmpestr (const struct builtin_description *d,
     }
   else if (d->code == IX86_BUILTIN_PCMPESTRM128)
     {
-      if (optimize || !target
+      if (GCC_OPTION (optimize) || !target
 	  || GET_MODE (target) != tmode1
 	  || !insn_data[d->icode].operand[1].predicate (target, tmode1))
 	target = gen_reg_rtx (tmode1);
@@ -33380,7 +33380,7 @@ ix86_expand_sse_pcmpistr (const struct builtin_description *d,
 
   if (!insn_data[d->icode].operand[2].predicate (op0, modev2))
     op0 = copy_to_mode_reg (modev2, op0);
-  if ((optimize && !register_operand (op1, modev3))
+  if ((GCC_OPTION (optimize) && !register_operand (op1, modev3))
       || !insn_data[d->icode].operand[3].predicate (op1, modev3))
     op1 = copy_to_mode_reg (modev3, op1);
 
@@ -33392,7 +33392,7 @@ ix86_expand_sse_pcmpistr (const struct builtin_description *d,
 
   if (d->code == IX86_BUILTIN_PCMPISTRI128)
     {
-      if (optimize || !target
+      if (GCC_OPTION (optimize) || !target
 	  || GET_MODE (target) != tmode0
 	  || !insn_data[d->icode].operand[0].predicate (target, tmode0))
 	target = gen_reg_rtx (tmode0);
@@ -33403,7 +33403,7 @@ ix86_expand_sse_pcmpistr (const struct builtin_description *d,
     }
   else if (d->code == IX86_BUILTIN_PCMPISTRM128)
     {
-      if (optimize || !target
+      if (GCC_OPTION (optimize) || !target
 	  || GET_MODE (target) != tmode1
 	  || !insn_data[d->icode].operand[1].predicate (target, tmode1))
 	target = gen_reg_rtx (tmode1);
@@ -33931,7 +33931,7 @@ ix86_expand_args_builtin (const struct builtin_description *d,
 
   if (rmode == VOIDmode || rmode == tmode)
     {
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  || target == 0
 	  || GET_MODE (target) != tmode
 	  || !insn_p->operand[0].predicate (target, tmode))
@@ -34073,7 +34073,7 @@ ix86_expand_args_builtin (const struct builtin_description *d,
 
 	  if (GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)
 	    {
-	      if (optimize || !match || num_memory > 1)
+	      if (GCC_OPTION (optimize) || !match || num_memory > 1)
 		op = copy_to_mode_reg (mode, op);
 	    }
 	  else
@@ -34245,10 +34245,10 @@ ix86_expand_sse_comi_round (const struct builtin_description *d,
   emit_move_insn (target, const0_rtx);
   target = gen_rtx_SUBREG (QImode, target, 0);
 
-  if ((optimize && !register_operand (op0, mode0))
+  if ((GCC_OPTION (optimize) && !register_operand (op0, mode0))
       || !insn_p->operand[0].predicate (op0, mode0))
     op0 = copy_to_mode_reg (mode0, op0);
-  if ((optimize && !register_operand (op1, mode1))
+  if ((GCC_OPTION (optimize) && !register_operand (op1, mode1))
       || !insn_p->operand[1].predicate (op1, mode1))
     op1 = copy_to_mode_reg (mode1, op1);
 
@@ -34384,7 +34384,7 @@ ix86_expand_round_builtin (const struct builtin_description *d,
     }
   gcc_assert (nargs <= ARRAY_SIZE (args));
 
-  if (optimize
+  if (GCC_OPTION (optimize)
       || target == 0
       || GET_MODE (target) != tmode
       || !insn_p->operand[0].predicate (target, tmode))
@@ -34440,7 +34440,7 @@ ix86_expand_round_builtin (const struct builtin_description *d,
 
 	  if (GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)
 	    {
-	      if (optimize || !match)
+	      if (GCC_OPTION (optimize) || !match)
 		op = copy_to_mode_reg (mode, op);
 	    }
 	  else
@@ -34729,7 +34729,7 @@ ix86_expand_special_args_builtin (const struct builtin_description *d,
   else
     {
       arg_adjust = 0;
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  || target == 0
 	  || !register_operand (target, tmode)
 	  || GET_MODE (target) != tmode)
@@ -34897,7 +34897,7 @@ ix86_expand_vec_ext_builtin (tree exp, rtx target)
 
   op0 = force_reg (mode0, op0);
 
-  if (optimize || !target || !register_operand (target, tmode))
+  if (GCC_OPTION (optimize) || !target || !register_operand (target, tmode))
     target = gen_reg_rtx (tmode);
 
   ix86_expand_vector_extract (true, target, op0, elt);
@@ -34991,7 +34991,7 @@ ix86_expand_builtin (tree exp, rtx target, rtx subtarget,
      options, we need to check in the context of the function making the call
      whether it is supported.  */
   if (ix86_builtins_isa[fcode].isa
-      && !(ix86_builtins_isa[fcode].isa & ix86_isa_flags))
+      && !(ix86_builtins_isa[fcode].isa & GCC_OPTION (ix86_isa_flags)))
     {
       char *opts = ix86_target_string (ix86_builtins_isa[fcode].isa, 0, NULL,
 				       NULL, (enum fpmath_unit) 0, false);
@@ -35511,7 +35511,7 @@ addcarryx:
     case IX86_BUILTIN_READ_FLAGS:
       emit_insn (gen_push (gen_rtx_REG (word_mode, FLAGS_REG)));
 
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  || target == NULL_RTX
 	  || !nonimmediate_operand (target, word_mode)
 	  || GET_MODE (target) != word_mode)
@@ -35828,7 +35828,7 @@ addcarryx:
 	 replace op0 with pc_rtx to signal that the instruction
 	 overwrites the whole destination and doesn't use its
 	 previous contents.  */
-      if (optimize)
+      if (GCC_OPTION (optimize))
 	{
 	  if (TREE_CODE (arg3) == INTEGER_CST)
 	    {
@@ -36190,7 +36190,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
     case BUILT_IN_LFLOOR:
     case BUILT_IN_LLFLOOR:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SImode && in_mode == DFmode)
@@ -36208,7 +36208,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
     case BUILT_IN_LFLOORF:
     case BUILT_IN_LLFLOORF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SImode && in_mode == SFmode)
@@ -36224,7 +36224,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
     case BUILT_IN_LCEIL:
     case BUILT_IN_LLCEIL:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SImode && in_mode == DFmode)
@@ -36242,7 +36242,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
     case BUILT_IN_LCEILF:
     case BUILT_IN_LLCEILF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SImode && in_mode == SFmode)
@@ -36282,7 +36282,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
     case BUILT_IN_LROUND:
     case BUILT_IN_LLROUND:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SImode && in_mode == DFmode)
@@ -36300,7 +36300,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
     case BUILT_IN_LROUNDF:
     case BUILT_IN_LLROUNDF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SImode && in_mode == SFmode)
@@ -36338,7 +36338,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_FLOOR:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == DFmode && in_mode == DFmode)
@@ -36352,7 +36352,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_FLOORF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SFmode && in_mode == SFmode)
@@ -36366,7 +36366,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_CEIL:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == DFmode && in_mode == DFmode)
@@ -36380,7 +36380,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_CEILF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SFmode && in_mode == SFmode)
@@ -36394,7 +36394,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_TRUNC:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == DFmode && in_mode == DFmode)
@@ -36408,7 +36408,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_TRUNCF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SFmode && in_mode == SFmode)
@@ -36422,7 +36422,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_RINT:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == DFmode && in_mode == DFmode)
@@ -36436,7 +36436,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_RINTF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SFmode && in_mode == SFmode)
@@ -36450,7 +36450,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_ROUND:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == DFmode && in_mode == DFmode)
@@ -36464,7 +36464,7 @@ ix86_builtin_vectorized_function (tree fndecl, tree type_out,
 
     case BUILT_IN_ROUNDF:
       /* The round insn does not trap on denormals.  */
-      if (flag_trapping_math || !TARGET_ROUND)
+      if (GCC_OPTION (flag_trapping_math) || !TARGET_ROUND)
 	break;
 
       if (out_mode == SFmode && in_mode == SFmode)
@@ -36522,7 +36522,7 @@ ix86_veclibabi_svml (enum built_in_function fn, tree type_out, tree type_in)
   int n, in_n;
 
   /* The SVML is suitable for unsafe math only.  */
-  if (!flag_unsafe_math_optimizations)
+  if (!GCC_OPTION (flag_unsafe_math_optimizations))
     return NULL_TREE;
 
   el_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -36639,7 +36639,7 @@ ix86_veclibabi_acml (enum built_in_function fn, tree type_out, tree type_in)
      it does not correctly support parts of IEEE with the required
      precision such as denormals.  */
   if (!TARGET_64BIT
-      || !flag_unsafe_math_optimizations)
+      || !GCC_OPTION (flag_unsafe_math_optimizations))
     return NULL_TREE;
 
   el_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -36807,8 +36807,8 @@ ix86_builtin_reciprocal (unsigned int fn, bool md_fn,
 			 bool sqrt ATTRIBUTE_UNUSED)
 {
   if (! (TARGET_SSE_MATH && !optimize_insn_for_size_p ()
-	 && flag_finite_math_only && !flag_trapping_math
-	 && flag_unsafe_math_optimizations))
+	 && GCC_OPTION (flag_finite_math_only) && !GCC_OPTION (flag_trapping_math)
+	 && GCC_OPTION (flag_unsafe_math_optimizations)))
     return NULL_TREE;
 
   if (md_fn)
@@ -37793,7 +37793,7 @@ ix86_rtx_costs (rtx x, int code_i, int outer_code_i, int opno, int *total,
 	*total = 3;
       else if (TARGET_64BIT && !x86_64_zext_immediate_operand (x, VOIDmode))
 	*total = 2;
-      else if (flag_pic && SYMBOLIC_CONST (x)
+      else if (GCC_OPTION (flag_pic) && SYMBOLIC_CONST (x)
 	       && (!TARGET_64BIT
 		   || (!GET_CODE (x) != LABEL_REF
 		       && (GET_CODE (x) != SYMBOL_REF
@@ -37839,7 +37839,7 @@ ix86_rtx_costs (rtx x, int code_i, int outer_code_i, int opno, int *total,
       /* Fall back to (MEM (SYMBOL_REF)), since that's where
 	 it'll probably end up.  Add a penalty for size.  */
       *total = (COSTS_N_INSNS (1)
-		+ (flag_pic != 0 && !TARGET_64BIT)
+		+ (GCC_OPTION (flag_pic) != 0 && !TARGET_64BIT)
 		+ (mode == SFmode ? 0 : mode == DFmode ? 1 : 2));
       return true;
 
@@ -38638,7 +38638,7 @@ x86_can_output_mi_thunk (const_tree thunk ATTRIBUTE_UNUSED,
     return false;
 
   /* Need a free register for GOT references.  */
-  if (flag_pic && !targetm.binds_local_p (function))
+  if (GCC_OPTION (flag_pic) && !targetm.binds_local_p (function))
     return false;
 
   /* Otherwise ok.  */
@@ -38746,7 +38746,7 @@ x86_output_mi_thunk (FILE *file,
   fnaddr = XEXP (DECL_RTL (function), 0);
   if (TARGET_64BIT)
     {
-      if (!flag_pic || targetm.binds_local_p (function)
+      if (!GCC_OPTION (flag_pic) || targetm.binds_local_p (function)
 	  || TARGET_PECOFF)
 	;
       else
@@ -38758,7 +38758,7 @@ x86_output_mi_thunk (FILE *file,
     }
   else
     {
-      if (!flag_pic || targetm.binds_local_p (function))
+      if (!GCC_OPTION (flag_pic) || targetm.binds_local_p (function))
 	;
 #if TARGET_MACHO
       else if (TARGET_MACHO)
@@ -38787,7 +38787,7 @@ x86_output_mi_thunk (FILE *file,
     emit_jump_insn (gen_indirect_jump (fnaddr));
   else
     {
-      if (ix86_cmodel == CM_LARGE_PIC && SYMBOLIC_CONST (fnaddr))
+      if (GCC_OPTION (ix86_cmodel) == CM_LARGE_PIC && SYMBOLIC_CONST (fnaddr))
 	fnaddr = legitimize_pic_address (fnaddr,
 					 gen_rtx_REG (Pmode, tmp_regno));
 
@@ -38829,7 +38829,7 @@ x86_file_start (void)
     fputs ("\t.version\t\"01.01\"\n", asm_out_file);
   if (X86_FILE_START_FLTUSED)
     fputs ("\t.global\t__fltused\n", asm_out_file);
-  if (ix86_asm_dialect == ASM_INTEL)
+  if (GCC_OPTION (ix86_asm_dialect) == ASM_INTEL)
     fputs ("\t.intel_syntax noprefix\n", asm_out_file);
 }
 
@@ -38854,7 +38854,7 @@ x86_field_alignment (tree field, int computed)
 void
 x86_function_profiler (FILE *file, int labelno ATTRIBUTE_UNUSED)
 {
-  const char *mcount_name = (flag_fentry ? MCOUNT_NAME_BEFORE_PROLOGUE
+  const char *mcount_name = (GCC_OPTION (flag_fentry) ? MCOUNT_NAME_BEFORE_PROLOGUE
 					 : MCOUNT_NAME);
 
   if (TARGET_64BIT)
@@ -38863,12 +38863,12 @@ x86_function_profiler (FILE *file, int labelno ATTRIBUTE_UNUSED)
       fprintf (file, "\tleaq\t%sP%d(%%rip),%%r11\n", LPREFIX, labelno);
 #endif
 
-      if (!TARGET_PECOFF && flag_pic)
+      if (!TARGET_PECOFF && GCC_OPTION (flag_pic))
 	fprintf (file, "\tcall\t*%s@GOTPCREL(%%rip)\n", mcount_name);
       else
 	fprintf (file, "\tcall\t%s\n", mcount_name);
     }
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     {
 #ifndef NO_PROFILE_COUNTERS
       fprintf (file, "\tleal\t%sP%d@GOTOFF(%%ebx),%%" PROFILE_COUNT_REGISTER "\n",
@@ -39268,7 +39268,7 @@ ix86_reorg (void)
   if (TARGET_SEH && current_function_has_exception_handlers ())
     ix86_seh_fixup_eh_fallthru ();
 
-  if (optimize && optimize_function_for_speed_p (cfun))
+  if (GCC_OPTION (optimize) && optimize_function_for_speed_p (cfun))
     {
       if (TARGET_PAD_SHORT_FUNCTION)
 	ix86_pad_short_function ();
@@ -41536,17 +41536,17 @@ ix86_stack_protect_fail (void)
 int
 asm_preferred_eh_data_format (int code, int global)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       int type = DW_EH_PE_sdata8;
       if (!TARGET_64BIT
-	  || ix86_cmodel == CM_SMALL_PIC
-	  || (ix86_cmodel == CM_MEDIUM_PIC && (global || code)))
+	  || GCC_OPTION (ix86_cmodel) == CM_SMALL_PIC
+	  || (GCC_OPTION (ix86_cmodel) == CM_MEDIUM_PIC && (global || code)))
 	type = DW_EH_PE_sdata4;
       return (global ? DW_EH_PE_indirect : 0) | DW_EH_PE_pcrel | type;
     }
-  if (ix86_cmodel == CM_SMALL
-      || (ix86_cmodel == CM_MEDIUM && code))
+  if (GCC_OPTION (ix86_cmodel) == CM_SMALL
+      || (GCC_OPTION (ix86_cmodel) == CM_MEDIUM && code))
     return DW_EH_PE_udata4;
   return DW_EH_PE_absptr;
 }
@@ -46184,7 +46184,7 @@ static bool
 has_dispatch (rtx insn, int action)
 {
   if ((TARGET_BDVER1 || TARGET_BDVER2 || TARGET_BDVER3 || TARGET_BDVER4)
-      && flag_dispatch_scheduler)
+      && GCC_OPTION (flag_dispatch_scheduler))
     switch (action)
       {
       default:
